import { computed as g, onMounted as et, ref as b, watch as tt, createElementBlock as m, openBlock as c, unref as d, normalizeStyle as P, normalizeClass as Ae, createBlock as B, createCommentVNode as x, createElementVNode as Y, createVNode as de, createSlots as ot, withCtx as $, renderSlot as k, normalizeProps as D, guardReactiveProps as R, Fragment as V, renderList as W, toDisplayString as j, createTextVNode as lt, nextTick as at } from "vue";
import { u as nt, o as st, e as rt, c as ve, t as ut, p as O, a as it, b as ct, v as _, d as dt, f as X, X as vt, G as Me, J as ft, i as fe, q as ht, r as pt, x as gt } from "./index-DvXHhwi7.js";
import { _ as mt } from "./Title-CiymPFBZ.js";
import { u as yt, U as bt } from "./usePrinter-D0Njbrwg.js";
import { D as kt } from "./DataTable-Dz3uePkM.js";
import Ct from "./vue-ui-accordion-rd6DBLB5.js";
import wt from "./vue-ui-skeleton-CJ9j8gHc.js";
import { u as He } from "./useNestedProp-Bw2_FZ80.js";
import { _ as $t } from "./PackageVersion-BNm7stW7.js";
import { _ as _t } from "./PenAndPaper-Ba1SBNDw.js";
import { u as Tt } from "./useUserOptionState-BIvW1Kz7.js";
import { u as xt } from "./useChartAccessibility-BWojgys7.js";
import { _ as Nt } from "./Tooltip-BXojuEca.js";
import { L as Ot } from "./Legend-DRjI7VTS.js";
import { _ as St } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ft = ["id"], Lt = {
  key: 1,
  ref: "noTitle",
  class: "vue-data-ui-no-title-space",
  style: "height:36px; width: 100%;background:transparent"
}, Pt = {
  key: 2,
  style: "width:100%;background:transparent;padding-bottom:24px"
}, It = ["xmlns", "viewBox"], Et = ["width", "height"], zt = ["id"], At = ["stop-color"], Mt = ["stop-color"], Ht = ["d", "fill", "stroke", "stroke-width"], Bt = ["x", "y", "height", "width", "fill", "stroke", "stroke-width", "onMouseenter"], Yt = ["x", "y", "font-size", "fill"], Dt = ["x", "y", "font-size", "fill"], Rt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, Gt = ["onClick"], Ut = {
  key: 6,
  ref: "source",
  dir: "auto"
}, Vt = ["innerHTML"], Wt = {
  __name: "vue-ui-flow",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(Be, { expose: Ye }) {
    const { vue_ui_flow: De } = nt(), T = Be, ee = g(() => !!T.dataset && T.dataset.length);
    et(() => {
      he();
    });
    function he() {
      st(T.dataset) && rt({
        componentName: "VueUiFlow",
        type: "dataset"
      });
    }
    const te = b(ve()), oe = b(null), pe = b(0), ge = b(0), le = b(!1), ae = b(""), Re = b(null), z = b(!1);
    function Ge(t) {
      z.value = t, pe.value += 1;
    }
    const e = g({
      get: () => ke(),
      set: (t) => t
    }), { userOptionsVisible: ne, setUserOptionsVisibility: me, keepUserOptionState: ye } = Tt({ config: e.value }), { svgRef: be } = xt({
      config: e.value.style.chart.title
    });
    function ke() {
      const t = He({
        userConfig: T.config,
        defaultConfig: De
      });
      let l = t;
      return t.theme ? l = {
        ...He({
          userConfig: it.vue_ui_flow[t.theme] || T.config,
          defaultConfig: t
        }),
        customPalette: ut[t.theme] || O
      } : l = t, l.nodeCategories = T.config.nodeCategories || {}, l.nodeCategoryColors = T.config.nodeCategoryColors || {}, l;
    }
    tt(
      () => T.config,
      (t) => {
        e.value = ke(), ne.value = !e.value.userOptions.showOnChartHover, he(), ge.value += 1, N.value.showTable = e.value.table.show;
      },
      { deep: !0 }
    );
    const { isPrinting: Ce, isImaging: we, generatePdf: $e, generateImage: _e } = yt({
      elementId: `flow_${te.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-flow",
      options: e.value.userOptions.print
    }), Ue = g(() => e.value.userOptions.show && !e.value.style.chart.title.text), q = g(() => ct(e.value.customPalette)), Te = g(() => e.value.style.chart.nodes.gap), A = g(() => e.value.style.chart.nodes.width), N = b({
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), Ve = g(() => e.value.style.chart.links.width), se = g(() => !T.dataset || !T.dataset.length ? [] : T.dataset.map((t, l) => [
      t[0],
      t[1],
      _(t[2]),
      t[3] ? dt(t[3]) : q.value[l] || q.value[l % q.value.length] || O[l] || O[l % O.length]
    ])), xe = g(() => {
      const t = {};
      function l(a) {
        t[a] || (t[a] = { inflow: 0, outflow: 0 });
      }
      se.value.forEach(([a, s, h]) => {
        l(a), l(s), t[a].outflow += h, t[s].inflow += h;
      });
      let o = 0;
      for (const a in t) {
        const s = Math.max(t[a].inflow, t[a].outflow);
        o = Math.max(o, s);
      }
      return o;
    });
    function We(t) {
      return t / xe.value * 100 + e.value.style.chart.nodes.minHeight;
    }
    function je(t) {
      const l = e.value.style.chart.nodes.minHeight;
      return (t - l) / 100 * xe.value;
    }
    function Xe(t) {
      const l = {}, o = {};
      function a(n, u) {
        l[n] || (l[n] = {
          height: 0,
          level: null,
          inflow: 0,
          outflow: 0,
          uid: ve()
        }), l[n].level === null && (l[n].level = u), o[u] || (o[u] = []), o[u].includes(n) || o[u].push(n);
      }
      t.forEach(([n, u, i]) => {
        var r;
        const v = ((r = l[n]) == null ? void 0 : r.level) ?? 0, p = v + 1;
        a(n, v), a(u, p), l[n].children || (l[n].children = []), l[n].children.push({ target: u, value: i }), l[n].outflow += i, l[u].inflow += i;
      });
      const s = new Set(t.map(([n]) => n)), h = new Set(t.map(([, n]) => n)), S = Array.from(s).filter((n) => !h.has(n)), U = {};
      S.forEach((n, u) => {
        U[n] = q.value[u] || O[u % O.length];
      });
      const E = {};
      t.forEach(([n, u, i, v]) => {
        v && (E[n] = v, E[u] = v);
      }), Object.keys(l).forEach((n, u) => {
        var p, r;
        const i = (p = e.value.nodeCategories) == null ? void 0 : p[n], v = i ? (r = e.value.nodeCategoryColors) == null ? void 0 : r[i] : null;
        l[n].color = E[n] || // 1) explicit
        v || // 2) category
        (S.includes(n) ? U[n] : null) || // 3) root
        O[u % O.length];
      });
      for (const n in l)
        l[n].height = We(
          Math.max(l[n].inflow, l[n].outflow)
        ), l[n].name = n;
      const w = {};
      for (const n in o) {
        let u = 0;
        o[n].forEach((i, v) => {
          const p = l[i];
          w[i] = {
            x: parseInt(n, 10) * Ve.value + e.value.style.chart.padding.left,
            y: u,
            absoluteY: u,
            height: p.height,
            i: v,
            color: p.color,
            value: je(p.height)
          }, u += p.height + Te.value;
        });
      }
      const F = [];
      for (const n of Object.keys(l)) {
        let u = w[n].absoluteY + e.value.style.chart.padding.top;
        const i = l[n], v = w[n];
        i.children && i.children.forEach(({ target: p, value: r }) => {
          const f = w[p], L = l[p], Q = _(u), Ee = _(
            u + r / i.outflow * v.height
          ), ce = _(
            f.y + e.value.style.chart.padding.top
          ), ze = _(
            ce + r / L.inflow * f.height
          );
          F.push({
            id: ve(),
            source: n,
            target: p,
            path: `M ${_(v.x + A.value)} ${Q} L ${_(v.x + A.value)} ${Ee} L ${_(f.x)} ${ze} L ${_(f.x)} ${ce} Z`,
            value: r,
            sourceColor: i.color,
            targetColor: L.color
          }), u += Ee - Q, w[p].y += ze - ce;
        });
      }
      return { nodeCoordinates: w, links: F };
    }
    const y = g(() => {
      const t = Xe(T.dataset);
      return {
        nodes: Object.keys(t.nodeCoordinates).map((l, o) => ({
          ...t.nodeCoordinates[l],
          name: l
        })),
        links: t.links
      };
    });
    g(() => qe(y.value.nodes));
    function qe(t) {
      const l = {};
      for (const a in t) {
        const { x: s, height: h } = t[a];
        l[s] || (l[s] = 0), l[s] += h + Te.value;
      }
      return Math.max(...Object.values(l));
    }
    const G = g(() => {
      const t = e.value.style.chart.padding, l = t.top, o = t.bottom, a = t.left, s = t.right, h = y.value.nodes.reduce(
        (H, w) => Math.max(H, w.x),
        0
      ), S = a + h + A.value + s, E = y.value.nodes.reduce((H, w) => {
        const n = w.y + l + w.height;
        return Math.max(H, n);
      }, 0) + o;
      return {
        width: S,
        height: E,
        left: a,
        top: l,
        right: s,
        bottom: o
      };
    });
    function Je(t) {
      const l = {}, o = {}, a = /* @__PURE__ */ new Set();
      return se.value.forEach(([s, h, S]) => {
        l[s] || (l[s] = []), o[h] || (o[h] = []), l[s].push(h), o[h].push(s);
      }), l[t] && l[t].forEach((s) => a.add(s)), o[t] && o[t].forEach((s) => a.add(s)), Array.from(a).concat(t);
    }
    const C = b(null), M = b(null), re = b(null), J = b(!1);
    function Ze(t) {
      I.value = [], C.value = Je(t.name), M.value = t.name;
      const l = t.name, o = se.value;
      let a = 0, s = 0, h = [], S = [];
      const U = new Set(o.map(([r]) => r)), E = new Set(o.map(([, r]) => r)), H = Array.from(U).filter((r) => !E.has(r)), w = o.filter(([r]) => H.includes(r)).reduce((r, [f, L, Q]) => r + Q, 0), F = {};
      y.value.nodes.forEach((r) => {
        F[r.name] = r.color;
      }), o.forEach(([r, f, L]) => {
        f === l && (a += L, h.push({ source: r, value: L, color: F[r] })), r === l && (s += L, S.push({ target: f, value: L, color: F[f] }));
      });
      const n = Math.max(a, s), u = w > 0 ? n / w * 100 : 0, i = {
        name: l,
        inflow: a,
        outflow: s,
        from: h,
        to: S,
        percentOfTotal: u,
        color: F[l] || "#000000"
      };
      re.value = { datapoint: i }, le.value = !0;
      let v = "";
      const p = e.value.style.chart.tooltip.customFormat;
      if (J.value = !1, gt(p))
        try {
          const r = p({
            datapoint: i,
            series: y.value,
            config: e.value
          });
          typeof r == "string" && (ae.value = r, J.value = !0);
        } catch {
          console.warn("Custom format cannot be applied.");
        }
      if (!J.value) {
        const r = e.value.style.chart.tooltip.showPercentage ? `<div>${X({
          p: e.value.style.chart.tooltip.translations.percentOfTotal,
          v: i.percentOfTotal,
          s: "%",
          r: e.value.style.chart.tooltip.roundingPercentage
        })}</div>` : "";
        v += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;"><span style="margin-right:4px; color:${i.color}">⏹</span>${i.name}${r}</div>`, i.from.length && (v += `<div>${e.value.style.chart.tooltip.translations.from}</div>`, i.from.forEach((f) => {
          v += `<div><span style="color:${f.color}">⏹←</span> ${f.source}: ${fe(
            e.value.style.chart.nodes.labels.formatter,
            f.value,
            X({
              p: e.value.style.chart.nodes.labels.prefix,
              v: f.value,
              s: e.value.style.chart.nodes.labels.suffix,
              r: e.value.style.chart.nodes.labels.rounding
            })
          )}</div>`;
        })), i.to.length && (v += `<div style="margin-top:6px;">${e.value.style.chart.tooltip.translations.to}</div>`, i.to.forEach((f) => {
          v += `<div><span style="color:${f.color}">⏹→</span> ${f.target}: ${fe(
            e.value.style.chart.nodes.labels.formatter,
            f.value,
            X({
              p: e.value.style.chart.nodes.labels.prefix,
              v: f.value,
              s: e.value.style.chart.nodes.labels.suffix,
              r: e.value.style.chart.nodes.labels.rounding
            })
          )}</div>`;
        })), ae.value = v;
      }
    }
    function Ne() {
      C.value = null, M.value = null, le.value = !1;
    }
    const Oe = g(() => y.value.links.map(
      ({ source: t, target: l, sourceColor: o, targetColor: a, value: s }) => ({
        source: t,
        target: l,
        sourceColor: o,
        targetColor: a,
        value: s
      })
    ));
    function Se() {
      at(() => {
        const t = Oe.value.map((a, s) => [[a.source], [a.target], [a.value]]), l = [
          [e.value.style.chart.title.text],
          [e.value.style.chart.title.subtitle.text],
          [
            [e.value.table.columnNames.source],
            [e.value.table.columnNames.target],
            [e.value.table.columnNames.value]
          ]
        ].concat(t), o = ht(l);
        pt({
          csvContent: o,
          title: e.value.style.chart.title.text || "vue-ui-flow"
        });
      });
    }
    const Z = g(() => {
      const t = [
        e.value.table.columnNames.source,
        e.value.table.columnNames.target,
        e.value.table.columnNames.value
      ], l = Oe.value.map((s, h) => [
        {
          color: s.sourceColor,
          name: s.source
        },
        {
          color: s.targetColor,
          name: s.target
        },
        X({
          p: e.value.style.chart.nodes.labels.prefix,
          v: s.value,
          s: e.value.style.chart.nodes.labels.suffix,
          r: e.value.style.chart.nodes.labels.rounding
        })
      ]), o = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.source,
          e.value.table.columnNames.target,
          e.value.table.columnNames.value
        ],
        head: t,
        body: l,
        config: o
      };
    });
    function Ke() {
      return y.value;
    }
    function Fe() {
      N.value.showTable = !N.value.showTable;
    }
    const K = b(!1);
    function ue() {
      K.value = !K.value;
    }
    function Le() {
      N.value.showTooltip = !N.value.showTooltip;
    }
    const Pe = g(() => {
      const t = new Set(
        y.value.nodes.map(
          (l) => e.value.nodeCategories[l.name] || "__uncategorized__"
        )
      );
      return Array.from(t).map((l) => ({
        name: l,
        color: e.value.nodeCategoryColors[l] || O[0],
        shape: "square",
        count: y.value.nodes.filter(
          (o) => (e.value.nodeCategories[o.name] || "__uncategorized__") === l
        ).length
      })).map((l, o) => ({
        ...l,
        segregate: () => ie({ legend: l, i: o }),
        opacity: I.value.length ? I.value.includes(o) ? 1 : 0.5 : 1
      }));
    }), Ie = g(
      () => Pe.value.filter((t) => t.name !== "__uncategorized__")
    ), I = b([]);
    function ie({ legend: t, i: l }) {
      var a;
      const o = t.name;
      if ((a = C.value) != null && a.every(
        (s) => e.value.nodeCategories[s] === o
      )) {
        C.value = null, M.value = null, I.value = [];
        return;
      }
      I.value = [l], C.value = y.value.nodes.filter((s) => e.value.nodeCategories[s.name] === o).map((s) => s.name), M.value = null;
    }
    const Qe = g(() => ({
      cy: "flow-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: e.value.style.chart.legend.paddingBottom,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : "normal"
    }));
    return Ye({
      getData: Ke,
      generateCsv: Se,
      generateImage: _e,
      generatePdf: $e,
      toggleTable: Fe,
      toggleAnnotator: ue,
      toggleTooltip: Le,
      drillCategory: ie,
      unselectNode: Ne
    }), (t, l) => (c(), m("div", {
      ref_key: "flowChart",
      ref: oe,
      class: Ae(`vue-ui-flow ${z.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      style: P(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;background:${e.value.style.chart.backgroundColor}`),
      id: `flow_${te.value}`,
      onMouseenter: l[3] || (l[3] = () => d(me)(!0)),
      onMouseleave: l[4] || (l[4] = () => d(me)(!1))
    }, [
      e.value.userOptions.buttons.annotator ? (c(), B(_t, {
        key: 0,
        svgRef: d(be),
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: K.value,
        onClose: ue
      }, null, 8, ["svgRef", "backgroundColor", "color", "active"])) : x("", !0),
      Ue.value ? (c(), m("div", Lt, null, 512)) : x("", !0),
      e.value.style.chart.title.text ? (c(), m("div", Pt, [
        (c(), B(mt, {
          key: `title_${ge.value}`,
          config: {
            title: {
              cy: "flow-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "flow-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ])) : x("", !0),
      e.value.userOptions.show && ee.value && (d(ye) || d(ne)) ? (c(), B(bt, {
        ref: "details",
        key: `user_option_${pe.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: d(Ce),
        isImaging: d(we),
        uid: te.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: z.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: oe.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: K.value,
        hasTooltip: e.value.style.chart.tooltip.show && e.value.userOptions.buttons.tooltip,
        isTooltip: N.value.showTooltip,
        onToggleTooltip: Le,
        onToggleFullscreen: Ge,
        onGeneratePdf: d($e),
        onGenerateCsv: Se,
        onGenerateImage: d(_e),
        onToggleTable: Fe,
        onToggleAnnotator: ue,
        style: P({
          visibility: d(ye) ? d(ne) ? "visible" : "hidden" : "visible"
        })
      }, ot({ _: 2 }, [
        t.$slots.menuIcon ? {
          name: "menuIcon",
          fn: $(({ isOpen: o, color: a }) => [
            k(t.$slots, "menuIcon", D(R({ isOpen: o, color: a })), void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: $(() => [
            k(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: $(() => [
            k(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: $(() => [
            k(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: $(() => [
            k(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: $(() => [
            k(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: $(({ toggleFullscreen: o, isFullscreen: a }) => [
            k(t.$slots, "optionFullscreen", D(R({ toggleFullscreen: o, isFullscreen: a })), void 0, !0)
          ]),
          key: "6"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: $(({ toggleAnnotator: o, isAnnotator: a }) => [
            k(t.$slots, "optionAnnotator", D(R({ toggleAnnotator: o, isAnnotator: a })), void 0, !0)
          ]),
          key: "7"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasXls", "hasImg", "hasTable", "hasFullscreen", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "hasTooltip", "isTooltip", "onGeneratePdf", "onGenerateImage", "style"])) : x("", !0),
      (c(), m("svg", {
        ref_key: "svgRef",
        ref: be,
        xmlns: d(vt),
        viewBox: `0 0 ${G.value.width} ${G.value.height}`,
        class: Ae({
          "vue-data-ui-fullscreen--on": z.value,
          "vue-data-ui-fulscreen--off": !z.value
        }),
        style: P(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        de($t),
        t.$slots["chart-background"] ? (c(), m("foreignObject", {
          key: 0,
          x: 0,
          y: 0,
          width: G.value.width,
          height: G.value.height,
          style: {
            pointerEvents: "none"
          }
        }, [
          k(t.$slots, "chart-background", {}, void 0, !0)
        ], 8, Et)) : x("", !0),
        Y("defs", null, [
          (c(!0), m(V, null, W(y.value.links, (o, a) => (c(), m("linearGradient", {
            id: o.id,
            x1: "0%",
            y1: "0%",
            x2: "100%",
            y2: "0%"
          }, [
            Y("stop", {
              offset: "0%",
              "stop-color": o.sourceColor
            }, null, 8, At),
            Y("stop", {
              offset: "100%",
              "stop-color": o.targetColor
            }, null, 8, Mt)
          ], 8, zt))), 256))
        ]),
        (c(!0), m(V, null, W(y.value.links, (o) => (c(), m("path", {
          class: "vue-ui-flow-link",
          d: o.path,
          fill: `url(#${o.id})`,
          stroke: e.value.style.chart.links.stroke,
          "stroke-width": e.value.style.chart.links.strokeWidth,
          style: P(`
                    opacity:${C.value ? C.value.includes(o.source) && C.value.includes(o.target) ? 1 : 0.3 : M.value ? [o.target, o.source].includes(M.value) ? 1 : 0.3 : e.value.style.chart.links.opacity}
                `)
        }, null, 12, Ht))), 256)),
        (c(!0), m(V, null, W(y.value.nodes, (o, a) => (c(), m("rect", {
          class: "vue-ui-flow-node",
          x: o.x,
          y: d(_)(o.absoluteY) + e.value.style.chart.padding.top,
          height: d(_)(o.height),
          width: A.value,
          fill: o.color,
          stroke: e.value.style.chart.nodes.stroke,
          "stroke-width": e.value.style.chart.nodes.strokeWidth,
          onMouseenter: (s) => Ze(o),
          onMouseleave: l[0] || (l[0] = (s) => Ne()),
          style: P(`opacity:${C.value ? C.value.includes(o.name) ? 1 : 0.3 : 1}`)
        }, null, 44, Bt))), 256)),
        (c(!0), m(V, null, W(y.value.nodes, (o, a) => (c(), m("text", {
          x: o.x + A.value / 2,
          y: d(_)(
            o.absoluteY + o.height / 2 - e.value.style.chart.nodes.labels.fontSize / 4
          ) + e.value.style.chart.padding.top,
          "font-size": e.value.style.chart.nodes.labels.fontSize,
          fill: d(Me)(o.color),
          "text-anchor": "middle",
          style: P(`pointer-events: none; opacity:${C.value ? C.value.includes(o.name) ? 1 : 0 : 1}`)
        }, j(e.value.style.chart.nodes.labels.abbreviation.use ? d(ft)({
          source: o.name,
          length: e.value.style.chart.nodes.labels.abbreviation.length
        }) : o.name), 13, Yt))), 256)),
        (c(!0), m(V, null, W(y.value.nodes, (o, a) => (c(), m("text", {
          x: o.x + A.value / 2,
          y: d(_)(
            o.absoluteY + o.height / 2 + e.value.style.chart.nodes.labels.fontSize
          ) + e.value.style.chart.padding.top,
          "font-size": e.value.style.chart.nodes.labels.fontSize,
          fill: d(Me)(o.color),
          "text-anchor": "middle",
          style: P(`pointer-events: none; opacity:${C.value ? C.value.includes(o.name) ? 1 : 0 : 1}`)
        }, j(d(fe)(
          e.value.style.chart.nodes.labels.formatter,
          o.value,
          d(X)({
            p: e.value.style.chart.nodes.labels.prefix,
            v: o.value,
            s: e.value.style.chart.nodes.labels.suffix,
            r: e.value.style.chart.nodes.labels.rounding
          }),
          { datapoint: o, seriesIndex: a }
        )), 13, Dt))), 256)),
        k(t.$slots, "svg", { svg: G.value }, void 0, !0)
      ], 14, It)),
      t.$slots.watermark ? (c(), m("div", Rt, [
        k(t.$slots, "watermark", D(R({ isPrinting: d(Ce) || d(we) })), void 0, !0)
      ])) : x("", !0),
      ee.value ? x("", !0) : (c(), B(wt, {
        key: 5,
        config: {
          type: "flow",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor
          }
        }
      }, null, 8, ["config"])),
      Y("div", {
        ref_key: "chartLegend",
        ref: Re
      }, [
        e.value.style.chart.legend.show && Ie.value.length ? (c(), B(Ot, {
          key: 0,
          legendSet: Ie.value,
          config: Qe.value,
          onClickMarker: l[1] || (l[1] = (o) => ie(o))
        }, {
          item: $(({ legend: o, index: a }) => [
            Y("div", {
              onClick: (s) => o.segregate(),
              style: P(`opacity:${I.value.length ? I.value.includes(a) ? 1 : 0.5 : 1}`)
            }, j(o.name) + " (" + j(o.count) + ") ", 13, Gt)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : x("", !0),
        k(t.$slots, "legend", { legend: Pe.value }, void 0, !0)
      ], 512),
      t.$slots.source ? (c(), m("div", Ut, [
        k(t.$slots, "source", {}, void 0, !0)
      ], 512)) : x("", !0),
      de(Nt, {
        show: N.value.showTooltip && le.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        fontSize: e.value.style.chart.tooltip.fontSize,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: oe.value,
        content: ae.value,
        isCustom: J.value,
        isFullscreen: z.value
      }, {
        "tooltip-before": $(() => [
          k(t.$slots, "tooltip-before", D(R({ ...re.value })), void 0, !0)
        ]),
        "tooltip-after": $(() => [
          k(t.$slots, "tooltip-after", D(R({ ...re.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom", "isFullscreen"]),
      ee.value ? (c(), B(Ct, {
        key: 7,
        hideDetails: "",
        config: {
          open: N.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: $(() => [
          de(kt, {
            colNames: Z.value.colNames,
            head: Z.value.head,
            body: Z.value.body,
            config: Z.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: l[2] || (l[2] = (o) => N.value.showTable = !1)
          }, {
            th: $(({ th: o }) => [
              Y("div", {
                innerHTML: o,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, Vt)
            ]),
            td: $(({ td: o }) => [
              lt(j(o.name || o), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"])
        ]),
        _: 1
      }, 8, ["config"])) : x("", !0)
    ], 46, Ft));
  }
}, uo = /* @__PURE__ */ St(Wt, [["__scopeId", "data-v-25e5df9a"]]);
export {
  uo as default
};
